mod message;
mod publication;
mod subscription;

pub use message::Message;
pub use publication::{Publication, SendError};
pub use subscription::{RecvError, Subscription};

#[derive(Clone, Debug, PartialEq)]
#[non_exhaustive]
pub enum SubscribeError {}

#[derive(Clone, Debug, PartialEq)]
#[non_exhaustive]
pub enum AdvertiseError {}

pub struct Orsb {}

impl Orsb {
    pub fn new() -> Self {
        todo!()
    }

    pub async fn subscribe<T: Message>(&mut self) -> Result<Subscription<T>, SubscribeError> {
        todo!()
    }

    pub async fn advertise<T: Message>(&mut self) -> Result<Publication<T>, AdvertiseError> {
        todo!()
    }

    pub fn subscribe_blocking<T: Message>(&mut self) -> Result<Subscription<T>, SubscribeError> {
        todo!()
    }

    pub fn advertise_blocking<T: Message>(&mut self) -> Result<Publication<T>, AdvertiseError> {
        todo!()
    }
}

#[cfg(test)]
mod test {
    use super::*;

    #[derive(Clone, Debug, PartialEq)]
    struct TestMsg(u8);

    #[test]
    fn test_sync() {
        let mut orsb = Orsb::new();

        let mut sub = orsb.subscribe_blocking::<TestMsg>().unwrap();
        let mut publ = orsb.advertise_blocking::<TestMsg>().unwrap();

        publ.send(TestMsg(10)).unwrap();
        publ.send(TestMsg(20)).unwrap();
        publ.send(TestMsg(30)).unwrap();

        assert_eq!(sub.recv_blocking(), Ok(TestMsg(10)));
        assert_eq!(sub.recv_blocking(), Ok(TestMsg(20)));
        assert_eq!(sub.recv_blocking(), Ok(TestMsg(30)));
        assert_eq!(sub.try_recv(), Err(RecvError::Empty));
    }
}
